/*******************************************************************************
 Rue's "is it alive" program for avr processors
  also makes a good skel to build your programs form.
*******************************************************************************/
 
/*

5 PB0   timer 0     9.216 MHz out     0C0A
6 PB1   timer 1     4 MHz out         OC1A
7 PB2        RESET out
8     (VCC)
4     (GND) 
2 PB3        XTAL 1
3 PB4        XTAL 2
1 PB5 (RESET)   

*/


#include <avr/io.h>
#include <avr/sleep.h>

#define OUTPUT             1
#define INPUT              0




#define SetBit(BIT, PORT)     PORT |= (1<<BIT)
#define ClearBit(BIT, PORT)   PORT &= ~(1<<BIT)
#define IsHigh(BIT, PORT)    (PORT & (1<<BIT)) != 0
#define IsLow(BIT, PORT)     (PORT & (1<<BIT)) == 0
#define NOP()                 asm volatile ("nop"::)

void Delay(unsigned long delay);
void ConfigTimers( void ) ;


int main (void) {

  // set up directions 

  DDRB  = (OUTPUT << PB0 | OUTPUT << PB1 |INPUT << PB2 |INPUT << PB3 |INPUT << PB4 |INPUT << PB5 );
  PRR   = ((1 << PRUSI) | (1 << PRADC));  // turn off usi and adc, dont need them for this.
 
  OSCCAL -= 0x05;
  ConfigTimers();
  
  SetBit  ( 2, PORTB );  // reset out high
  SetBit  ( 2, DDRB  );  // as an output now
  ClearBit( 2, PORTB );  // now go low, lifting reset for the system
    
  MCRUCR = (1 << SE); // ENABLE SYSTEM SLEEP (IDLE MODE) 
  sleep_mode();  
    
 
  while(1) {        
    NOP();       // well its not like there is anything else going on to take up the memory
    NOP(); 
    NOP(); 
    NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();    
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); 
    NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();        
  }     
  
}

void ConfigTimers( void ) {

  // timer 0   9.216 MHz
  // [external crystal] 18.432 MHz external /2 = 9.216 MHz
  // WGM0 = 111   CS0 = 001  COM0 = 01  OCR0A = 0 
  
  TCCR0B = ( 1 << WGM02 );                                                   // WGM02 = 1, CS02 = 0, CS01 = 0, CS00 = 1
  TCCR0A = (( 1 << COM0A0 ) | ( 1 << WGM01 ) | ( 1 << WGM00 ));              // COM0A1 = 0, COM0A0 = 1, WGM01 = 1, WGM00 = 1
  OCR0A  = 0;                                                                // immediate toggle
  TCCR0B |=   ( 1 << CS00 );                                                 // enable
  
  // timer 1  4MHz
  // PCLK must be more than 3x core clock freq
  // [internal clock] 8 Mhz *8 = 64MHz /16 = 4MHz
  //  CS1 = 0001   COM1 =    OCR1C = 
  
  //  COM1A1 = 0, COM1A0 = 1, CS13 = 0, CS12 = 0, CS11 = 0, CS10 = 1
  
    // turning on the pll is a process...
    PLLCSR |= (1<<PLLE);
    while (IsLow(PLOCK, PLLCSR));  // wait for pll to lock
    PLLCSR |= (1<<PCKE);
  
    OCR1C  = 7;                                                               // DIVIDE BY 8
    TCCR1  = (( 1 << COM1A0 ) | ( 1 << CS10 ) | ( 1 << CTC1)) ;               // COM1A1 = , COM1A0 = 1 , CS13 = 0, CS12 = 0, CS11 = 0, CS10 = 1, CTC1 = 1     

}

void Delay(unsigned long delay) {
  unsigned long x;
  for (x = delay; x != 0; x--) {
    asm volatile ("nop"::); 
  }
}






